<?php
################################################################################
# @Name : /core/mail.php
# @Description : page to send mail
# @Call : /preview_mail.php, /core_automail.php
# @Parameters : ticket id destinataires
# @Author : Flox
# @Create : 15/07/2014
# @Update : 06/03/2015
# @Version : 3.1.7
################################################################################

//initialize variables 
if(!isset($_POST['usercopy'])) $_POST['usercopy'] = '';
if(!isset($_POST['usercopy2'])) $_POST['usercopy2'] = '';
if(!isset($_POST['usercopy3'])) $_POST['usercopy3'] = '';
if(!isset($_POST['usercopy4'])) $_POST['usercopy4'] = '';
if(!isset($_POST['usercopy5'])) $_POST['usercopy5'] = '';
if(!isset($_POST['usercopy6'])) $_POST['usercopy6'] = '';
if(!isset($_POST['receiver'])) $_POST['receiver'] = ''; 
if(!isset($_POST['withattachment'])) $_POST['withattachment'] = ''; 
if(!isset($fname11)) $fname11 = '';
if(!isset($fname21)) $fname21 = '';
if(!isset($fname31)) $fname31 = '';
if(!isset($fname41)) $fname41 = '';
if(!isset($fname51)) $fname51 = '';
if(!isset($resolution)) $resolution = '';

//database queries to find values for create mail	
$globalquery = $db->query("SELECT * FROM tincidents WHERE id LIKE '$_GET[id]'");
$globalrow=$globalquery->fetch();
$query->closeCursor();

$userquery = $db->query("SELECT * FROM tusers WHERE id LIKE '$globalrow[user]'");
$userrow=$userquery->fetch();
$query->closeCursor();	
	
$techquery = $db->query("SELECT * FROM tusers WHERE id LIKE '$globalrow[technician]'");
$techrow=$techquery->fetch();
$query->closeCursor();
	
$creatorquery = $db->query("SELECT * FROM tusers WHERE id LIKE '$_SESSION[user_id]'");
$creatorrow=$creatorquery->fetch();
$query->closeCursor();
	
$querystate = $db->query("SELECT name FROM tstates WHERE id LIKE '$globalrow[state]'");
$staterow=$querystate->fetch();
$query->closeCursor();
	
$querycat = $db->query("SELECT * FROM tcategory WHERE id LIKE '$globalrow[category]'");
$catrow=$querycat->fetch();
$query->closeCursor();
	
$querysubcat = $db->query("SELECT * FROM tsubcat WHERE id LIKE '$globalrow[subcat]'");
$subcatrow=$querysubcat->fetch();
$query->closeCursor();

//generate resolution
$query = $db->query("SELECT * FROM tthreads WHERE ticket='$_GET[id]' and prive=0 ORDER BY date");
while ($row = $query->fetch())
{
	//remove display date from old post 
	$find_old=explode(" ", $row['date']);
	$find_old=$find_old[1];
	if ($find_old!='12:00:00') $date_thread=date_convert($row['date']); else  $date_thread='';
		
	if($row['type']==0)
	{
		//text backline format
		$text=nl2br($row['text']);
		
		//test if author is not the technician
		if ($row['author']!=$globalrow['technician'])
		{
			//find author name
			$qauthor = $db->query("SELECT * FROM tusers WHERE id='$row[author]'");
			$rauthor=$qauthor->fetch();
			$resolution="$resolution <b> $date_thread $rauthor[firstname] $rauthor[lastname]: </b><br /> $text  <hr />";
		} else {
			if ($date_thread!='')
			{
				$resolution="$resolution <b>$date_thread:</b><br />$text<hr />";
			} else {
				$resolution="$resolution  $text <hr />";
			}
		}
	} 
	if ($row['type']==1)
	{
		//tech name
		$qtech3=$db->query("SELECT * FROM tusers WHERE id='$row[tech1]'");
		$rtech3=$qtech3->fetch();
		$resolution="$resolution <b>$date_thread:</b> Attribution du ticket à $rtech3[firstname] $rtech3[lastname].<br /><br />";
	}
	if($row['type']==2)
	{
		//tech name
		$qtech1 = $db->query("SELECT * FROM tusers WHERE id='$row[tech1]'");
		$rtech1=$qtech1->fetch();
		$qtech2=$db->query("SELECT * FROM tusers WHERE id='$row[tech2]'");
		$rtech2=$qtech2->fetch();
		$resolution="$resolution <b>$date_thread:</b> Transfert du ticket de $rtech1[firstname] $rtech1[lastname] à $rtech2[firstname] $rtech2[lastname]. <br /><br />";
	}
	
}
	
$description = $globalrow['description'];
	
//dates conversions
$date_create = date_cnv("$globalrow[date_create]");
$date_hope = date_cnv("$globalrow[date_hope]");
$date_res = date_cnv("$globalrow[date_res]");
	
//mail object for states
$qobject = $db->query("SELECT * FROM tstates WHERE id LIKE '$globalrow[state]'");
$robject=$qobject->fetch();
$objet="$robject[mail_object] pour le ticket n°$_GET[id]: $globalrow[title]";

$destinataire="$userrow[mail]";

//check if unique sender mail adress exist else get creator mail adress
if($rparameters['mail_from_adr']==''){$emetteur=$creatorrow['mail'];} else {$emetteur=$rparameters['mail_from_adr'];}

//interger link parameter
if ($rparameters['mail_link']==1)
{
	$link=", ou consultez votre ticket sur ce lien: <a href=\"$rparameters[server_url]/index.php?page=ticket&id=$_GET[id]\">$rparameters[server_url]/index.php?page=ticket&id=$_GET[id]</a>";	
} else $link=".";
	
$msg="
	<html>
		<head>
			<meta charset=\"UTF-8\" />
		</head>
		<body>
			<font face=\"Arial\">
				<table  width=\"820px\" cellspacing=\"0\" cellpadding=\"10\">
					<tr bgcolor=\"$rparameters[mail_color_title]\" >
					  <th><font size=\"4\" color=\"FFFFFF\"> &nbsp; $objet &nbsp;</font></th>
					</tr>
					<tr bgcolor=\"$rparameters[mail_color_bg]\" >
					  <td>
						$rparameters[mail_txt]<br />
						<br />
						<table  border=\"1\" bordercolor=\"$rparameters[mail_color_title]\" cellspacing=\"0\"  cellpadding=\"5\">
							<tr>
								<td><font color=\"$rparameters[mail_color_text]\"><b>Titre:</b></b> $globalrow[title]</font></td>
								<td><font color=\"$rparameters[mail_color_text]\"><b>Catégorie:</b></b> $catrow[1] - $subcatrow[2]</td>
							</tr>
							<tr>
								<td width=\"400px\"><font color=\"$rparameters[mail_color_text]\"><b>Demandeur:</b></b> $userrow[lastname] $userrow[firstname]</font></td>
								<td width=\"400px\"><font color=\"$rparameters[mail_color_text]\"><b>Technicien en charge:</b> $techrow[lastname] $techrow[firstname]</font></td>
							</tr>
							<tr>
								<td><font color=\"$rparameters[mail_color_text]\"><b>Etat:</b> $staterow[0]</font></td>
								<td><font color=\"$rparameters[mail_color_text]\"><b>Date de la demande:</b> $date_create</font></td>	
							</tr> 
							<tr>
								<td colspan=\"2\"><font color=\"$rparameters[mail_color_text]\"><b>Description:</b><br /> $description</font></td>
								
							</tr>
							<tr>
								<td colspan=\"2\"><font color=\"$rparameters[mail_color_text]\"><b>Résolution:</b><br /> $resolution</font></td>
							</tr>
							<tr>
								<td width=\"400px\"><font color=\"$rparameters[mail_color_text]\"><b>Date estimée de résolution:</b></b> $date_hope</font></td>
								<td width=\"400px\"><font color=\"$rparameters[mail_color_text]\"><b>Date de résolution:</b> $date_res</font></td>
							</tr>
						</table>
						<br />
						<hr />
						Pour toutes informations complémentaires sur votre ticket, vous pouvez joindre $techrow[firstname] $techrow[lastname] au $techrow[phone]
						$link
					  </td>
					</tr>
				</table>
			</font>
		</body>
	</html>"."\r\n";

if ($send==1)
{
	if ($rparameters['debug']==1) {echo '<b>SMTP SERVER:</b><br />';}
	require("components/PHPMailer-5.2.13/PHPMailerAutoload.php"); 
	$mail = new PHPmailer();
	$mail->CharSet = 'UTF-8'; //ISO-8859-1 possible if characters problems
	if ($rparameters['mail_smtp_class']=='IsSendMail()') {$mail->IsSendMail();} else {$mail->IsSMTP();} 
	if($rparameters['mail_secure']=='SSL') 
	{$mail->Host = "ssl://$rparameters[mail_smtp]";} 
	elseif($rparameters['mail_secure']=='TLS') 
	{$mail->Host = "tls://$rparameters[mail_smtp]";} 
	else 
	{$mail->Host = "$rparameters[mail_smtp]";}
	$mail->SMTPAuth = $rparameters['mail_auth'];
	if ($rparameters['debug']==1) $mail->SMTPDebug = 2;
	if ($rparameters['mail_secure']!=0) $mail->SMTPSecure = $rparameters['mail_secure'];
	if ($rparameters['mail_port']!=25) $mail->Port = $rparameters['mail_port'];
	$mail->Username = "$rparameters[mail_username]";
	$mail->Password = "$rparameters[mail_password]";
	$mail->IsHTML(true); 
	$mail->From = "$emetteur";
	$mail->FromName = "$rparameters[mail_from_name]";
	//generate adresse list
	if ($_POST['receiver']!='none') {
		if ($globalrow['u_group']!=0)
		{
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$globalrow[u_group] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddAddress("$row[0]");
		} else $mail->AddAddress("$userrow[mail]");
	}
	if ($rparameters['mail_from_adr']!='') {$mail->AddReplyTo("$rparameters[mail_from_adr]");} else {$mail->AddReplyTo("$techrow[mail]");}
	if ($rparameters['mail_cc']!='') {
		$addresses = explode(";",$rparameters['mail_cc']);
		foreach($addresses as $mailCC){
			$mail->AddCC("$mailCC");
		}
	}
	if ($_POST['usercopy']!='')
	{ 
		if(substr($_POST['usercopy'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch())$mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy]");
	}
	if ($_POST['usercopy2']!='')
	{ 
		if(substr($_POST['usercopy2'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy2']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy2]");
	}
	if ($_POST['usercopy3']!='')
	{ 
		if(substr($_POST['usercopy3'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy3']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy3]");
	}
	if ($_POST['usercopy4']!='')
	{ 
		if(substr($_POST['usercopy4'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy4']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy4]");
	}
	if ($_POST['usercopy5']!='')
	{ 
		if(substr($_POST['usercopy5'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy5']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy5]");
	}
	if ($_POST['usercopy6']!='')
	{ 
		if(substr($_POST['usercopy6'], 0, 1) =='G') 
		{
			$groupid= explode("_", $_POST['usercopy6']);
			$qgroup = $db->query("SELECT mail FROM `tusers`, `tgroups_assoc` WHERE tgroups_assoc.user=tusers.id AND tgroups_assoc.group=$groupid[1] AND tusers.disable=0");
			while ($row = $qgroup->fetch()) $mail->AddCC("$row[0]");
		} else $mail->AddCC("$_POST[usercopy6]");
	}
    if ($_POST['withattachment']==1)
    {
    	if ($globalrow['img1']!='')$mail->AddAttachment("./upload/$_GET[id]/$globalrow[img1]");
    	if ($globalrow['img2']!='')$mail->AddAttachment("./upload/$_GET[id]/$globalrow[img2]");
    	if ($globalrow['img3']!='')$mail->AddAttachment("./upload/$_GET[id]/$globalrow[img3]");
    	if ($globalrow['img4']!='')$mail->AddAttachment("./upload/$_GET[id]/$globalrow[img4]");
    	if ($globalrow['img5']!='')$mail->AddAttachment("./upload/$_GET[id]/$globalrow[img5]");
    }
	$mail->Subject = "$objet";
	$mail->Body = "$msg";
	if (!$mail->Send()){
    	echo '<div class="alert alert-block alert-danger"><center><i class="icon-remove red"></i> <b>Message non envoyé, vérifier la configuration de votre serveur de messagerie.</b> (';
        	echo $mail->ErrorInfo;
    	echo ')</center></div>';
	}
	else {
		echo '<div class="alert alert-block alert-success"><center><i class="icon-envelope green"></i> Message envoyé.</center></div>';
		//redirect
		echo "
		<SCRIPT LANGUAGE='JavaScript'>
		<!--
		function redirect()
		{
		window.location='./index.php?page=dashboard&&state=$_GET[state]&userid=$_GET[userid]'
		}
		setTimeout('redirect()',$rparameters[time_display_msg]);
		-->
		</SCRIPT>
		";
	}
	$mail->SmtpClose();
}


///////Functions

// Date conversion
function date_cnv ($date) 
{return substr($date,8,2) . "/" . substr($date,5,2) . "/" . substr($date,0,4);}
?>